<script>
import VideoModal from './video-modal.vue';
import {
  IsMobileMixin,
  UseLiteVimeo,
  UseLocalizedVideoSubtitles,
} from '~/mixins';

export default {
  components: {
    VideoModal,
  },
  mixins: [IsMobileMixin, UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      modalIsOpen: false,
      currentVideoUrl: '',
      categories: [],
      selectedCategory: '',
      allCards: [],
      activeDot: 0,
      innerStyles: {},
    };
  },

  computed: {
    filterByCategory() {
      return this.data.cards.filter(
        (card) => card.event_type === this.selectedCategory,
      );
    },
    dots() {
      return this.filterByCategory.length;
    },
  },
  mounted() {
    this.allCards = this.visibleCards();
  },
  beforeMount() {
    this.categories = Array.from(
      new Set(this.data.cards.map((card) => card.event_type)),
    );

    [this.selectedCategory] = this.categories;
  },
  methods: {
    visibleCards() {
      if (
        (this.isMobile && this.filterByCategory.length > 1) ||
        this.filterByCategory.length > 3
      ) {
        let cardsToShow = this.filterByCategory.slice(
          this.activeDot,
          this.activeDot + 3,
        );

        if (cardsToShow.length < 3) {
          const extraCardsNeeded = 3 - cardsToShow.length;

          cardsToShow = [
            ...cardsToShow,
            ...this.filterByCategory.slice(0, extraCardsNeeded),
          ];
        }

        return cardsToShow;
      }
      return this.filterByCategory;
    },
    moveLeft() {
      this.innerStyles = {
        transform: `translateX(300px)`,
      };
    },
    moveRight() {
      this.innerStyles = {
        transform: `translateX(-300px)`,
      };
    },
    prev() {
      this.moveLeft();

      this.afterTransition(() => {
        this.activeDot = (this.activeDot - 1 + this.dots) % this.dots;
        this.allCards = this.visibleCards();

        this.resetTranslate();
      });
    },

    next() {
      this.moveRight();

      this.afterTransition(() => {
        this.activeDot = (this.activeDot + 1) % this.dots;
        this.allCards = this.visibleCards();

        this.resetTranslate();
      });
    },

    resetTranslate() {
      this.innerStyles = {
        transition: 'none',
        transform: 'translateX(0)',
      };
    },
    afterTransition(callback) {
      const listener = () => {
        callback();
        this.$refs.videoCardContainer.removeEventListener(
          'transitionend',
          listener,
        );
      };
      this.$refs.videoCardContainer.addEventListener('transitionend', listener);
    },
    goToDot(index) {
      const diff = this.activeDot - index;

      this.innerStyles = {
        transform: `translateX(${diff * 300}px)`,
      };

      this.afterTransition(() => {
        this.activeDot = index;
        this.allCards = this.visibleCards();
        this.resetTranslate();
      });
    },
    openModal(url) {
      if (this.selectedCategory === 'Video') {
        this.modalIsOpen = true;
        this.currentVideoUrl = url;
      } else {
        window.location.href = url;
      }
    },
    closeModal() {
      this.modalIsOpen = false;
      this.currentVideoUrl = '';
    },
    switchCategory(category) {
      this.selectedCategory = category;
      this.activeDot = 0;
      this.allCards = this.visibleCards();
    },
  },
};
</script>

<template>
  <div class="carousel">
    <SlpTypography tag="h2" variant="heading2-bold">
      {{ data.title || 'Resources' }}</SlpTypography
    >
    <div class="resources-tabs">
      <SlpTypography
        v-for="category in categories"
        :key="category"
        variant="body2-bold"
        :class="{ active: category === selectedCategory }"
        @click.native="switchCategory(category)"
      >
        {{ $tc(`resourceCategories.${category.toLowerCase()}`, 2) || category }}
      </SlpTypography>
    </div>
    <div style="overflow: hidden">
      <div
        ref="videoCardContainer"
        class="video-card-container"
        :style="innerStyles"
      >
        <div
          v-for="(card, index) in allCards"
          :key="index + card?.header"
          class="resources-block"
          @click="openModal(card?.href)"
        >
          <div class="resources-block__wrapper">
            <div class="resources-block__content-top">
              <div class="resources-block__icon slp-flex">
                <SlpIcon
                  v-if="card?.icon && !card?.icon.use_local_icon"
                  :name="card?.icon.name"
                  :variant="card?.icon.variant"
                  :alt="card?.icon.alt"
                  slp-color="text-300"
                />
                <img
                  v-else-if="card?.icon"
                  :src="card?.icon.name"
                  :alt="card?.icon.alt"
                  loading="lazy"
                />
                <SlpTypography
                  tag="p"
                  variant="body2"
                  class="resources-block__type"
                  >{{ card?.event_type }}
                </SlpTypography>
              </div>
              <div v-if="selectedCategory === 'Video'" class="image-container">
                <SlpIcon
                  class="icon"
                  name="play-circle"
                  variant="marketing"
                  size="lg"
                  slp-color="text-primary-200"
                />
                <img
                  class="resources-block__image slp-my-24"
                  :src="
                    card?.image ||
                    card?.fallback_image ||
                    '/nuxt-images/resources/fallback/img-fallback-cards-infinity.png'
                  "
                  alt=""
                  loading="lazy"
                />
              </div>
              <img
                v-else
                class="resources-block__image slp-my-24"
                :src="
                  card?.image ||
                  card?.fallback_image ||
                  '/nuxt-images/resources/fallback/img-fallback-cards-infinity.png'
                "
                alt=""
                loading="lazy"
              />
              <SlpTypography tag="h3" variant="heading5-bold"
                >{{ card?.header }}
              </SlpTypography>
            </div>
            <div class="resources-block__content-bottom">
              <SlpTypography
                variant="body2-bold"
                tag="span"
                class="resources-block__link"
                >{{ card?.link_text }}
                <SlpIcon
                  class="slp-ml-8"
                  variant="product"
                  name="chevron-lg-right"
                />
              </SlpTypography>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div v-if="(isMobile && dots > 1) || dots > 3" class="controls">
      <div class="dots">
        <button class="control-btn prev" @click="prev">
          <SlpIcon variant="product" name="chevron-lg-left" />
        </button>
        <span
          v-for="(_, index) in dots"
          :key="index + Math.random()"
          :class="{
            activedot: activeDot === index,
          }"
          class="dot"
          @click="goToDot(index)"
        ></span>
        <button class="control-btn next" @click="next">
          <SlpIcon variant="product" name="chevron-lg-right" />
        </button>
      </div>
    </div>
    <VideoModal
      v-show="modalIsOpen"
      light-background
      :visible="modalIsOpen"
      @close="modalIsOpen = false"
    >
      <template #body>
        <!-- Use Embed video url -->
        <lite-vimeo
          ref="video"
          :videoid="getVimeoVideoId(createVideoSource(currentVideoUrl))"
          autoplay
        ></lite-vimeo> </template
    ></VideoModal>
  </div>
</template>

<style scoped lang="scss">
.carousel {
  margin: $spacing-64 0 150px 0;
  text-align: left;
  width: 100%;

  .resources-tabs {
    display: flex;
    justify-content: flex-start;
    overflow: scroll;
    position: relative;
    margin: $spacing-48 0;
    max-width: fit-content;

    &::-webkit-scrollbar {
      display: none;
    }

    @media (max-width: $breakpoint-md) {
      justify-content: flex-start;
    }

    span {
      transition: all 0.2s;
      cursor: pointer;
      width: auto;
      padding: 0 $spacing-24 $spacing-16 $spacing-24;
      white-space: nowrap;
      text-align: center;
      border-bottom: 4px solid transparent;
      position: relative;
    }

    .active {
      border-bottom: 4px solid #7759c2;
    }

    &:before {
      content: '';
      height: 2px;
      width: 100%;
      background: $color-surface-900;
      position: absolute;
      bottom: 0;
    }
  }
}

.video-card-container {
  display: flex;
  align-items: flex-start;
  scroll-behavior: smooth;
  width: 900px;
  height: 500px;
  margin-bottom: $spacing-32;
  transition: transform 0.3s ease-in-out;
  overflow: hidden;

  &__transition-group {
    display: flex;
    overflow-x: hidden;
    align-items: flex-start;
    scroll-behavior: smooth;
    width: 100%;
    white-space: nowrap;
  }
}

.dot {
  display: inline-block;
  width: 10px;
  height: 10px;
  border-radius: 50%;
  background-color: $color-surface-300;
  margin: 0 $spacing-8;
  cursor: pointer;

  &:first-of-type {
    margin: 0 $spacing-8 0 0;
  }
  &:last-of-type {
    margin: 0 0 0 $spacing-8;
  }
}

.dot.activedot {
  background-color: $color-surface-700;
}

.controls {
  display: flex;
  justify-content: flex-start;
  align-items: center;

  .control-btn {
    background-color: transparent;
    border: none;
    cursor: pointer;
    font-size: 24px;
    vertical-align: sub;
  }
}
.resources-block {
  cursor: pointer;
  display: flex;
  position: relative;
  width: 100%;
  max-width: 320px;

  @media (min-width: $breakpoint-md) {
    min-width: 300px;
    max-width: 300px;
  }

  &__wrapper {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    padding: $spacing-32 $spacing-16;
    height: 100%;
    min-height: 480px;
    min-width: 100%;
    width: 100%;
    overflow: hidden;

    @media (min-width: $breakpoint-md) {
      min-width: 300px;
      max-width: 300px;
    }
    &:hover {
      background: $color-surface-900;
      border-bottom-right-radius: 100px;
    }
  }

  &__header {
    width: 100%;
    display: flex;
    flex-direction: column;

    @media (min-width: $breakpoint-md) {
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
    }
  }

  &__line {
    border-top: 2px solid $color-surface-400;

    &.slp-hr {
      margin: $spacing-32 0;
    }
  }

  &__image {
    width: 100%;
    max-height: 200px;
    max-width: 318px;
    height: 200px;
    object-fit: cover;
  }

  &__link {
    color: $color-text-300;
    padding-left: 0;
    display: flex;
    align-items: center;
  }

  &__type {
    margin-left: $spacing-8;
  }

  &__content-text {
    color: $color-text-300;
  }

  &__content-top {
    p,
    h3 {
      color: $color-text-300;
    }
  }

  &__icon {
    .resources-block__image {
      max-width: 1rem;
    }
    img {
      width: $spacing-16;
      height: $spacing-16;
    }
  }
  &__button {
    @media (min-width: $breakpoint-md) {
      min-width: fit-content;
      margin-left: 20%;
    }
  }
  h3 {
    text-align: left;
    text-overflow: ellipsis;
  }
}
.image-container {
  position: relative;
  .icon {
    position: absolute;
    bottom: 40%;
    left: 40%;
  }
}
</style>
